FUNCTION PINPOT(b1,b2,b3,b4,RK,AK,NATOMTOT,NATOM,NSUB,RS,basis,PRIMLATT,LATTCONST,NSHELL,TOL)
      IMPLICIT NONE
      DOUBLE PRECISION :: PINPOT
      DOUBLE PRECISION :: B1,B2,B3,B4,RK(7),AK(7),RKK(8),AKK(8)
      INTEGER :: NATOMTOT,NATOM,NSUB,NSHELL,NSKAL
      DOUBLE PRECISION :: RS(NATOMTOT,3),PRIMLATT(3,3),LATTCONST,TOL,RSHELL,RR(3),R1(3),R2(3),R3(3),R
      DOUBLE PRECISION :: V(NSHELL),V1,V2,basis(NATOM,3),mep,deg,VATOM(NATOM)
      DOUBLE PRECISION, ALLOCATABLE :: RT(:,:,:,:)
      INTEGER :: i,j,k,l,n1,n2,n3,pp,NUMBSUPERCELLS,mm,nn(NSHELL)
      mep = 0.0001
      DO i=1,6
        AKK(i) = AK(i)
        RKK(i) = RK(i)
      ENDDO
      AKK(7) = b1
      AKK(8) = b2
      RKK(7) = b3
      RKK(8) = b4
      
      NUMBSUPERCELLS = (NSHELL+1)**3
      ALLOCATE(RT(NSHELL,NUMBSUPERCELLS,NATOMTOT,3))
      
      ! Calculating the atomic positions of all shells
    DO i=1,NSHELL  
      mm = 0
      R2(1) =1.0d0*i
      R2(2) =1.0d0*i
      R2(3) =1.0d0*i
      nn(i) = (i+1)**3
      DO n1=0,i
        DO n2=0,i
          DO n3=0,i
            mm = mm +1
            R1(1) = n1*1.0d0
            R1(2) = n2*1.0d0
            R1(3) = n3*1.0d0
            DO j=1,NATOMTOT
                RT(i,mm,j,:) = RS(j,:) + R1 - R2
            ENDDO
        ENDDO
       ENDDO
      ENDDO
    ENDDO
                  DO i=NSHELL-1,NSHELL
                        V(i) = 0.0d0
                        V1 = 0.0d0
                        V2 = 0.0d0
                        DO n1=1,NATOM
                           DO n2=1,nn(i)
                              DO n3=1,NATOMTOT
                               R1=RT(i,n2,n3,:)
                                 R2 = R1 -basis(n1,:)
                                 R1 = MATMUL(PRIMLATT,R2)*LATTCONST
                                 R = sqrt(DOT_PRODUCT(R1,R1))
                                 DO pp=1,6
                                 IF ( RKK(pp) - R .GE. 0.0d0 ) THEN
                                    IF ( R .GT. mep ) THEN
                                        V1 = V1 + 0.50d0*AKK(pp)*(RKK(pp) - R)**3
                                    ENDIF
                                 ENDIF
                                 ENDDO
                                 DO pp=7,8
                                        IF ( RKK(pp) - R .GE. 0.0d0  ) THEN
                                          IF ( R .GT. mep ) THEN
                                                  V2= V2 + AKK(pp)*(RKK(pp)-R)**3
                                          ENDIF
                                        ENDIF
                                 ENDDO

                              ENDDO
                            ENDDO
                            VATOM(n1) = (V1-sqrt(V2))
                            V1 = 0
                            V2 = 0 
                        ENDDO
                        DO j=1,NATOM
                                V(i) = V(i)+VATOM(j)
                        ENDDO
                        V(i) = V(i)/(1.0d0*NATOM)
                   ENDDO 

                                        
        PINPOT = V(NSHELL)
        k= NSHELL-1
        IF ( i .EQ. NSHELL .AND. DABS(V(NSHELL)-V(k)) .LT. TOL ) THEN
                print*,'WARNING: |V(NSHELL)-V(NSHELL-1)| > TOL IN FUNCTION: ZRPOT'
                print*,'INCREASE NSHELL'
        ENDIF       
       
        DEALLOCATE(RT)
      
        END FUNCTION PINPOT
