FUNCTION gaussdistrib(Tol,Xmax)
   !This function generates a random numbers with a gaussian distribution
   !The distribution have meansquare deviation = 1/sqrt(2).
   !Tol is the maximum length of the interval (x1,x2) in whch the random
   !number is contained. Xmax is the cutoff value of the gaussian distribution
   ! g(x > Xmax) = 0.
   IMPLICIT NONE
   DOUBLE PRECISION :: gaussdistrib
   INTEGER :: INTGRALSAMPLE,ISEED,I
   DOUBLE PRECISION :: Tol,Xmax
   DOUBLE PRECISION :: INTERVAL,DX,XM,X1,X2,XX1,XX2,Y1,Y2,INTEGRAL,ITOT,J
   REAL(KIND=8)  :: r
   DOUBLE PRECISION, PARAMETER :: PI = 3.1415926535897932384626433832795028841971693993751
   INTGRALSAMPLE = 1000
   X1 = 0.0d0
   X2 = Xmax 
   XM = 0.50d0
   INTERVAL = 10.0d0
   ITOT = 0.50d0
   DO WHILE( INTERVAL .GT. Tol )
                DX = (XM-X1)/INTGRALSAMPLE
                INTEGRAL = 0.0d0
                DO I=1,INTGRALSAMPLE
                        XX1 = X1+DX*(I-1)
                        XX2 = XX1+DX
                        Y1 = (1.0d0/sqrt(PI))*exp(-XX1**2)
                        Y2 = (1.0d0/sqrt(PI))*exp(-XX2**2)
                        INTEGRAL = INTEGRAL+DX*(Y1+Y2)*0.50d0
                ENDDO
                CALL RANDOM_NUMBER(r)
                IF ( r .LT. INTEGRAL/ITOT) THEN
                        X2 = XM
                        XM = 0.50d0*(X1+X2)
                        ITOT = INTEGRAL
                ELSE
                        X1 = XM
                        XM = 0.50d0*(X1+X2)
                        ITOT = ITOT-INTEGRAL
                ENDIF
                INTERVAL = abs(X2-X1)
        ENDDO
        gaussdistrib = 0.50d0*(X1+X2)
END FUNCTION gaussdistrib
