SUBROUTINE readforces(FORCES,NATOMTOT,NDISP,DISPL,ITTER)
      ! If ITTER > 0 this routine reads in the forces 
      ! from the KRAFTER -file ( a file containing the forces calculated
      ! by VASP ). If ITTER = 0 the routine reads the files:
      ! KRAFTER.1, KRAFTER.2, ..., KRAFTER.N where N = number of 
      ! displacements used for calculating the initial phonon spectrum,
      ! and prints the forces contained in these files together with
      ! the displacements ---> file: FORCES

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NATOMTOT,NDISP,ITTER
      DOUBLE PRECISION, INTENT(IN) :: DISPL(24)
      DOUBLE PRECISION, INTENT(OUT) :: FORCES(NATOMTOT,3)
      DOUBLE PRECISION :: KRAFT(NDISP,NATOMTOT,3)
      INTEGER :: i,j,nn,n1,n2,n3
      LOGICAL :: finns
      IF ( ITTER .GT. 0 ) THEN
              inquire(file='KRAFTER',exist=finns)
              IF (.not. finns ) STOP 'cannot find file KRAFTER'
              OPEN(20,FILE='KRAFTER',STATUS='OLD',ACTION='READ')
              DO i =1,NATOMTOT
                READ(20,*)FORCES(i,1),FORCES(i,2),FORCES(i,3)
              ENDDO
              close(20)
      ELSE
              DO i=1,NDISP
                 IF ( i .EQ.1 ) THEN
                         inquire(file='KRAFTER.1',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.1'
                         OPEN(30,FILE='KRAFTER.1',STATUS='OLD',ACTION='READ')
                 ENDIF
                 IF ( i .EQ.2 ) THEN
                         inquire(file='KRAFTER.2',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.2'
                         OPEN(30,FILE='KRAFTER.2',STATUS='OLD',ACTION='READ')
                 ENDIF
                 IF ( i .EQ.3 ) THEN
                         inquire(file='KRAFTER.3',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.3'
                         OPEN(30,FILE='KRAFTER.3',STATUS='OLD',ACTION='READ')
                 ENDIF
                 IF ( i .EQ.4 ) THEN
                         inquire(file='KRAFTER.4',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.4'
                         OPEN(30,FILE='KRAFTER.4',STATUS='OLD',ACTION='READ')
                 ENDIF
                 IF ( i .EQ.5 ) THEN
                         inquire(file='KRAFTER.5',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.5'
                         OPEN(30,FILE='KRAFTER.5',STATUS='OLD',ACTION='READ')
                 ENDIF
                 IF ( i .EQ.6 ) THEN
                         inquire(file='KRAFTER.6',exist=finns)
                         IF (.not. finns ) STOP 'cannot find file KRAFTER.6'
                         OPEN(30,FILE='KRAFTER.6',STATUS='OLD',ACTION='READ')
                 ENDIF
                 DO j =1,NATOMTOT
                        READ(30,*)KRAFT(i,j,1),KRAFT(i,j,2),KRAFT(i,j,3)
                 ENDDO
                 close(30)
               ENDDO

               OPEN(40,FILE='FORCES',ACTION='WRITE')
               1 FORMAT(I3)
               2 FORMAT(I3,X,3(F15.10,2X))
               3 FORMAT(3(F30.10,2X))
               WRITE(40,FMT=1)NDISP
               DO i=1,NDISP
                nn = DINT(DISPL(1+(i-1)*4))
                n1 = 2+4*(i-1)
                n2 = 3+4*(i-1)
                n3 = 4+4*(i-1)
                WRITE(40,FMT=2)nn,DISPL(n1),DISPL(n2),DISPL(n3)
                DO j=1,NATOMTOT
                        WRITE(40,FMT=3)KRAFT(i,j,1),KRAFT(i,j,2),KRAFT(i,j,3)
                ENDDO
               ENDDO
               close(40)
       ENDIF

END SUBROUTINE readforces
