PROGRAM test_getlatt
        IMPLICIT NONE
        DOUBLE PRECISION :: PRIMLATT(3,3),RECLATT(3,3),A,TEMP,MASSA(10),SYMOPF(48,3,3)
        INTEGER :: NUMBATOMS,NTYPEATOM,SSZ(3),k,NSYMREL,i,j,pp
        EXTERNAL :: getlatt,getsymblock
        INTEGER, ALLOCATABLE :: SYMBLOCK(:,:,:,:)
        call getlatt(PRIMLATT,RECLATT,A,NUMBATOMS,NTYPEATOM,TEMP,SSZ,MASSA)
        print*,'PRIMITIVE LATTICE:'
        print*,PRIMLATT
        print*,'RECIPROCAL LATTICE:'
        print*,RECLATT
        print*,'Lattice constant:',A
        print*,'Number of atoms:',NUMBATOMS
        print*,'Number of atom types:',NTYPEATOM
        print*,'Temperature:',TEMP
        print*,'Supercell size:',SSZ
        print*,'Mass of ions:'
        DO k=1,NTYPEATOM
                print*,MASSA(k)
        ENDDO
        ! Here we test the getsymblock-routine
        NSYMREL = (NUMBATOMS*SSZ(1)*SSZ(2)*SSZ(3))**2
        ALLOCATE(SYMBLOCK(NUMBATOMS,NUMBATOMS,NSYMREL,4))
        call getsymblock(NUMBATOMS,SSZ,NSYMREL,SYMBLOCK,SYMOPF)
        DO i = 1,NUMBATOMS
                DO j = 1,NUMBATOMS
                        pp = 0
                        print*,'Symmetry relations for block (i,j)=',i,j
                        symloop: DO k=1,NSYMREL
                                        IF ( SYMBLOCK(i,j,k,4) < 0 )  EXIT symloop
                                        print*,SYMBLOCK(i,j,k,1),SYMBLOCK(i,j,k,2),SYMBLOCK(i,j,k,3)
                                        pp = pp+1
                                 ENDDO symloop
                                 print*,'Number of symmetry relations=',pp
                         ENDDO 
         ENDDO
         ! Here we test if the symmetry operations has been properly stored
         print*,'Printing the rotational matrices'
         1 FORMAT(3(F20.15))
         DO i =1,24
                print*,i
                WRITE(*,FMT=1)SYMOPF(i,1,1),SYMOPF(i,1,2),SYMOPF(i,1,3)
                WRITE(*,FMT=1)SYMOPF(i,2,1),SYMOPF(i,2,2),SYMOPF(i,2,3)
                WRITE(*,FMT=1)SYMOPF(i,3,1),SYMOPF(i,3,2),SYMOPF(i,3,3)
          ENDDO
END PROGRAM test_getlatt
